package net.minecraft.item;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.List;
import java.util.Properties;

import net.minecraft.block.Block;
import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.texture.IIconRegister;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.entity.Entity;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Blocks;
import net.minecraft.util.IIcon;
import net.minecraft.world.World;

import org.lwjgl.input.Keyboard;

public class ItemBlock extends Item {
	protected final Block field_150939_a; // block
	private IIcon field_150938_b;
	private static final String __OBFID = "CL_00001772";

	public ItemBlock(Block block) {
		this.field_150939_a = block;
	}

	/**
	 * Sets the unlocalized name of this item to the string passed as the
	 * parameter, prefixed by "item."
	 */
	public ItemBlock setUnlocalizedName(String name) {
		super.setUnlocalizedName(name);
		return this;
	}

	/**
	 * Returns 0 for /terrain.png, 1 for /gui/items.png
	 */
	public int getSpriteNumber() {
		return this.field_150939_a.getItemIconName() != null ? 1 : 0;
	}

	/**
	 * Gets an icon index based on an item's damage value
	 */
	public IIcon getIconFromDamage(int damage) {
		return this.field_150938_b != null ? this.field_150938_b : this.field_150939_a.getBlockTextureFromSide(1);
	}

	/**
	 * Callback for item usage. If the item does something special on right
	 * clicking, he will have one of those. Return True if something happen and
	 * false if it don't. This is for ITEMS, not BLOCKS
	 * 
	 * Bullshit, it's for blocks! Well okay items that reference blocks, which means placing them. :D
	 */
	public boolean onItemUse(ItemStack stack, EntityPlayer player, World world, int x, int y, int z, int rot, float px,
			float py, float pz) {
		
		/* INSERT A */
		int nx = x;
		int ny = y;
		int nz = z;
		/* END INSERT A */
		
		Block nBlock = world.getBlock(x, y, z);
		if(nBlock == Blocks.snow_layer && (world.getBlockMetadata(x, y, z) & 7) < 1) {
			rot = 1;
		} else if(nBlock != Blocks.vine && nBlock != Blocks.tallgrass && nBlock != Blocks.deadbush) {
			if(rot == 0) {
				--y;
			}

			if(rot == 1) {
				++y;
			}

			if(rot == 2) {
				--z;
			}

			if(rot == 3) {
				++z;
			}

			if(rot == 4) {
				--x;
			}

			if(rot == 5) {
				++x;
			}
		}

		if(stack.stackSize == 0) {
			return false;
		} else if(!player.canPlayerEdit(x, y, z, rot, stack)) {
			return false;
		} else if(y == 255 && this.field_150939_a.getMaterial().isSolid()) {
			return false;
			
		/* INSERT B */
		} else if (Keyboard.isKeyDown(keyToPress)) {
			int ax = x - nx;
			int ay = y - ny;
			int az = z - nz;

			int max_build = maximumToPlace;
			if (ay != 0) {
				max_build = maximumVertToPlace;
			}
			
			for (int built = 0; stack.stackSize > 0 && built < max_build &&
			// This is checking if we can place a block at XYZ
			// COPY THE world. from the first if AFTER the end of this insert
					world.canPlaceEntityOnSide(this.field_150939_a, x, y, z, false, rot, player, stack)
			// END COPY
					; ++built) {

				// COPY FROM AFTER the above world. thing above, and before another IF
				int metadata = this.getMetadata(stack.getItemDamage());
				int placedFlags = this.field_150939_a.onBlockPlaced(world, x, y, z, rot, px, py, pz, metadata);
				// END COPY

				// Copy the first IF from below in the world. and add a ! sign here
				if (!world.setBlock(x, y, z, this.field_150939_a, placedFlags, 3)) {
					break;
				}

				// COPY FROM within the above if statement below
				if(world.getBlock(x, y, z) == this.field_150939_a) {
					this.field_150939_a.onBlockPlacedBy(world, x, y, z, player, stack);
					this.field_150939_a.onPostBlockPlaced(world, x, y, z, placedFlags);
				}

				world.playSoundEffect((double) ((float) x + 0.5F), (double) ((float) y + 0.5F), (double) ((float) z + 0.5F),
						this.field_150939_a.stepSound.func_150496_b(), (this.field_150939_a.stepSound.func_150497_c() + 1.0F) / 2.0F,
						this.field_150939_a.stepSound.func_150494_d() * 0.8F);
				--stack.stackSize;
				// END COPY
				
				x += ax;
				y += ay;
				z += az;
			}

			return true;
			/* END INSERT B */
		} else if(world.canPlaceEntityOnSide(this.field_150939_a, x, y, z, false, rot, player, stack)) {
			int metadata = this.getMetadata(stack.getItemDamage());
			int placedFlags = this.field_150939_a.onBlockPlaced(world, x, y, z, rot, px, py, pz, metadata);

			if(world.setBlock(x, y, z, this.field_150939_a, placedFlags, 3)) {
				if(world.getBlock(x, y, z) == this.field_150939_a) {
					this.field_150939_a.onBlockPlacedBy(world, x, y, z, player, stack);
					this.field_150939_a.onPostBlockPlaced(world, x, y, z, placedFlags);
				}

				world.playSoundEffect((double) ((float) x + 0.5F), (double) ((float) y + 0.5F), (double) ((float) z + 0.5F),
						this.field_150939_a.stepSound.func_150496_b(), (this.field_150939_a.stepSound.func_150497_c() + 1.0F) / 2.0F,
						this.field_150939_a.stepSound.func_150494_d() * 0.8F);
				--stack.stackSize;
			}

			return true;
		} else {
			return false;
		}
	}

	public boolean func_150936_a(World world, int x, int y, int z, int rot, EntityPlayer player, ItemStack stack) {
		Block nBlock = world.getBlock(x, y, z);

		if(nBlock == Blocks.snow_layer) {
			rot = 1;
		} else if(nBlock != Blocks.vine && nBlock != Blocks.tallgrass && nBlock != Blocks.deadbush) {
			if(rot == 0) {
				--y;
			}

			if(rot == 1) {
				++y;
			}

			if(rot == 2) {
				--z;
			}

			if(rot == 3) {
				++z;
			}

			if(rot == 4) {
				--x;
			}

			if(rot == 5) {
				++x;
			}
		}

		return world.canPlaceEntityOnSide(this.field_150939_a, x, y, z, false, rot, (Entity) null, stack);
	}

	/**
	 * Returns the unlocalized name of this item. This version accepts an
	 * ItemStack so different stacks can have different names based on their
	 * damage or NBT.
	 */
	public String getUnlocalizedName(ItemStack p_77667_1_) {
		return this.field_150939_a.getUnlocalizedName();
	}

	/**
	 * Returns the unlocalized name of this item.
	 */
	public String getUnlocalizedName() {
		return this.field_150939_a.getUnlocalizedName();
	}

	/**
	 * gets the CreativeTab this item is displayed on
	 */
	public CreativeTabs getCreativeTab() {
		return this.field_150939_a.getCreativeTabToDisplayOn();
	}

	/**
	 * This returns the sub items
	 */
	public void getSubItems(Item item, CreativeTabs tabs, List list) {
		this.field_150939_a.getSubBlocks(item, tabs, list);
	}

	public void registerIcons(IIconRegister ireg) {
		String var2 = this.field_150939_a.getItemIconName();

		if(var2 != null) {
			this.field_150938_b = ireg.registerIcon(var2);
		}
	}
	
	
	/* INSERT MISC */
	private static int keyToPress = Keyboard.KEY_LCONTROL;
	private static int maximumToPlace = 24;
	private static int maximumVertToPlace = 12;

	static {
		System.out.println("FastBuild : Loading key binding.");
		/* get base directory here */
		Minecraft minecraft = Minecraft.getMinecraft();
		File file = new File(minecraft.mcDataDir.getAbsolutePath() + File.separator
				+ "config" + File.separator + "fastbuild.cfg");
		Properties config;
		if (file.exists()) {
			config = new Properties();
			try {
				config.load(new FileInputStream(file));
				try {
					maximumToPlace = Integer.parseInt(config.getProperty(
							"max_stack_build_num").trim());
					if (maximumToPlace < 1) {
						maximumToPlace = 1;
					}
					if (maximumToPlace > 64) {
						maximumToPlace = 64;
					}
				} catch (Exception ex) {
					/* We don't care if we fail. */
				}

				try {
					maximumVertToPlace = Integer.parseInt(config.getProperty(
							"max_stack_vertical_build_num").trim());
					if (maximumVertToPlace < 1) {
						maximumVertToPlace = 1;
					}
					if (maximumVertToPlace > 64) {
						maximumVertToPlace = 64;
					}
				} catch (Exception ex) {
					maximumVertToPlace = maximumToPlace;
				}

				System.out.println("FastBuild : Max placement set to "
						+ maximumToPlace + ".");

				try {
					String bkey = config.getProperty("build_key");
					if (bkey != null && bkey.startsWith("KEY_")) {
						keyToPress = Keyboard.getKeyIndex(bkey.substring(4));
					}
				} catch (Exception ex) {
					/* Yet again. We don't care if we fail. */
				}

				System.out.println("FastBuild : Using build key \'"
						+ Keyboard.getKeyName(keyToPress) + "\'.");

			} catch (Exception ex) {
				/* Yet yet again. We don't care if we fail. */
			}
		} else {
			System.out.println("FastBuild : Config not found, creating.");
			config = new Properties();
			config.put("build_key", "KEY_LCONTROL");
			config.put("max_stack_build_num", "" + maximumToPlace);
			config.put("max_stack_vertical_build_num", "" + maximumVertToPlace);
			try {
				/* Make any required directories. */
				file.mkdirs();
				config.store(
						new FileOutputStream(file),
						" \n#Any KEY_ value from http://www.lwjgl.org/javadoc/org/lwjgl/input/Keyboard.html, `should` work.\n"
						+ "# Warning: Conflicts with built in key bindings is possible!\n#");
			} catch (Exception ex) {
				/* We really don't care if we fail. */
			}
		}
	}
	/* END INSERT MISC */
}
